<?php

use Premmerce\Optimizer\OptimizerPlugin;

/**
 *
 * Plugin Name:       Premmerce Performance Optimizer
 * Plugin URI:        https://premmerce.com
 * Description:       Plugin optimize woocommerce store performance
 * Version:           1.1.4
 * Author:            20script
 * Author URI:        https://www.20script.ir
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       premmerce-performance-optimizer
 * Domain Path:       /languages
 *
 *
 * WC requires at least: 3.0.0
 * WC tested up to: 3.6
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

call_user_func( function () {

	require_once plugin_dir_path( __FILE__ ) . 'vendor/autoload.php';
	require_once plugin_dir_path( __FILE__ ) . 'freemius.php';

	$main = new OptimizerPlugin( __FILE__ );

	register_activation_hook( __FILE__, [ $main, 'activate' ] );

	register_deactivation_hook( __FILE__, [ $main, 'deactivate' ] );

	register_uninstall_hook( __FILE__, [ OptimizerPlugin::class, 'uninstall' ] );

	$main->run();
} );