<?php namespace Premmerce\Optimizer\WooCommerce;

class ProductFactory extends \WC_Product_Factory
{
    private $cachedProducts = array();

    public function get_product($product_id = false, $deprecated = array())
    {
        $product_id = $this->get_product_id($product_id);

        if (isset($this->cachedProducts[$product_id]) && !defined('WOOCOMMERCE_CHECKOUT')) {
            return $this->cachedProducts[$product_id];
        } else {
            $product = parent::get_product($product_id, $deprecated);
            $this->cachedProducts[$product_id] = $product;

            return $product;
        }
    }

    private function get_product_id($product)
    {
        global $post;

        if (false === $product && isset($post, $post->ID) && 'product' === get_post_type($post->ID)) {
            return absint($post->ID);
        } elseif (is_numeric($product)) {
            return $product;
        } elseif ($product instanceof \WC_Product) {
            return $product->get_id();
        } elseif (! empty($product->ID)) {
            return $product->ID;
        } else {
            return false;
        }
    }
}
